/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: h8_3048f.h,v 1.4 2008/04/24 18:22:15 roi Exp $
 */

#ifndef TOPPERS_H8_3048F_H_
#define TOPPERS_H8_3048F_H_

/*
 *  H8/3048F 
 */


/*  ֹκ  */
#define TMAX_INTNO			61U

/*  IRQֹ(intno)κ/Ǿ  */
#define TMAX_INTNO_IRQ		17U
#define TMIN_INTNO_IRQ		12U

/*  IRQֹκ  */
#define TMAX_IRQ_NO			5U

/*  IPRA쥸ǳߥ٥Ǥֹκ  */
#define TMAX_INTNO_IPRA		34U




/* Interrupt numbers */

#define TINTNO_NMI			 7U		/* NMI */

#define TINTNO_TRAP8		 8U

#define TINTNO_IRQ0			12U		/* IRQ0 */
#define TINTNO_IRQ1			13U		/* IRQ1 */
#define TINTNO_IRQ2			14U		/* IRQ2 */
#define TINTNO_IRQ3			15U		/* IRQ3 */
#define TINTNO_IRQ4			16U		/* IRQ4 */
#define TINTNO_IRQ5			17U		/* IRQ5 */

#define TINTNO_WOVI         20U     /* Watch Doc Timer */

#define TINTNO_CMI          21U     /* Compare Match */

#define TINTNO_IMIA0        24U     /* ITU0 IMIA0 */
#define TINTNO_IMIB0        25U     /* ITU0 IMIB0 */
#define TINTNO_OVI0         26U     /* ITU0 OVI0  */

#define TINTNO_IMIA1        28U     /* ITU1 IMIA1 */
#define TINTNO_IMIB1        29U     /* ITU1 IMIB1 */
#define TINTNO_OVI1         30U     /* ITU1 OVI1  */

#define TINTNO_IMIA2        32U     /* ITU2 IMIA2 */
#define TINTNO_IMIB2        33U     /* ITU2 IMIB2 */
#define TINTNO_OVI2         34U     /* ITU2 OVI2  */

#define TINTNO_IMIA3        36U     /* ITU3 IMIA3 */
#define TINTNO_IMIB3        37U     /* ITU3 IMIB3 */
#define TINTNO_OVI3         38U     /* ITU3 OVI3  */

#define TINTNO_IMIA4        40U     /* ITU4 IMIA4 */
#define TINTNO_IMIB4        41U     /* ITU4 IMIB4 */
#define TINTNO_OVI4         42U     /* ITU4 OVI4  */

#define TINTNO_DEND0A       44U     /* DMAC */
#define TINTNO_DEND0B       45U     /* DMAC */
#define TINTNO_DEND1A       46U     /* DMAC */
#define TINTNO_DEND1B       47U     /* DMAC */

#define TINTNO_ERI0         52U     /* SCI0 ERI */
#define TINTNO_RXI0         53U     /* SCI0 RXI */
#define TINTNO_TXI0         54U     /* SCI0 TXI */
#define TINTNO_TEI0         55U     /* SCI0 TEI */

#define TINTNO_ERI1         56U     /* SCI1 ERI */
#define TINTNO_RXI1         57U     /* SCI1 RXI */
#define TINTNO_TXI1         58U     /* SCI1 TXI */
#define TINTNO_TEI1         59U     /* SCI1 TEI */

#define TINTNO_ADI          60U     /* A/D */

/* 
 * ӥåֹӥåȥѥѴޥ
 */
#define H8_BITNO_TO_BITPTN(no)  (UINT32_C(1) << (no))


/* register address */

/* I/O ports */

/* port1: A0  - A7  */

#define H8P1DDR             UINT32_C(0xffffc0)
#define H8P1DR              UINT32_C(0xffffc2)

/* port2: A8  - A15 */

#define H8P2DDR             UINT32_C(0xffffc1)
#define H8P2DR              UINT32_C(0xffffc3)
#define H8P2PCR             UINT32_C(0xffffd8)

/* port3: D8  - D15 */

#define H8P3DDR             UINT32_C(0xffffc4)
#define H8P3DR              UINT32_C(0xffffc6)

/* port4: D0  - D7  */

#define H8P4DDR             UINT32_C(0xffffc5)
#define H8P4DR              UINT32_C(0xffffc7)
#define H8P4PCR             UINT32_C(0xffffda)

/* port5: A16 - A19 */

#define H8P5DDR             UINT32_C(0xffffc8)
#define H8P5DR              UINT32_C(0xffffca)
#define H8P5PCR             UINT32_C(0xffffdb)

#define H8P5DDR_A19_BIT     UINT32_C(3)
#define H8P5DDR_A18_BIT     UINT32_C(2)
#define H8P5DDR_A17_BIT     UINT32_C(1)
#define H8P5DDR_A16_BIT     UINT32_C(0)

#define H8P5DDR_A19         H8_BITNO_TO_BITPTN(H8P5DDR_A19_BIT)
#define H8P5DDR_A18         H8_BITNO_TO_BITPTN(H8P5DDR_A18_BIT)
#define H8P5DDR_A17         H8_BITNO_TO_BITPTN(H8P5DDR_A17_BIT)
#define H8P5DDR_A16         H8_BITNO_TO_BITPTN(H8P5DDR_A16_BIT)

/* port6 */

#define H8P6DDR             UINT32_C(0xffffc9)
#define H8P6DR              UINT32_C(0xffffcb)

#define H8P6DDR_HWR_BIT     UINT32_C(6)
#define H8P6DDR_LWR_BIT     UINT32_C(5)
#define H8P6DDR_RD_BIT      UINT32_C(4)
#define H8P6DDR_AS_BIT      UINT32_C(3)
#define H8P6DDR_BACK_BIT    UINT32_C(2)
#define H8P6DDR_BREQ_BIT    UINT32_C(1)
#define H8P6DDR_WAIT_BIT    UINT32_C(0)

#define H8P6DDR_HWR         (UINT32_C(1)<<H8P6DDR_HWR_BIT)
#define H8P6DDR_LWR         (UINT32_C(1)<<H8P6DDR_LWR_BIT)
#define H8P6DDR_RD          (UINT32_C(1)<<H8P6DDR_RD_BIT)
#define H8P6DDR_AS          (UINT32_C(1)<<H8P6DDR_AS_BIT)
#define H8P6DDR_BACK        (UINT32_C(1)<<H8P6DDR_BACK_BIT)
#define H8P6DDR_BREQ        (UINT32_C(1)<<H8P6DDR_BREQ_BIT)
#define H8P6DDR_WAIT        (UINT32_C(1)<<H8P6DDR_WAIT_BIT)

/* port7 */

#define H8P7DR              UINT32_C(0xffffce)

/* port8 */

#define H8P8DDR             UINT32_C(0xffffcd)
#define H8P8DR              UINT32_C(0xffffcf)

#define H8P8DDR_CS0_BIT     UINT32_C(4)
#define H8P8DDR_CS1_BIT     UINT32_C(3)
#define H8P8DDR_CS2_BIT     UINT32_C(2)
#define H8P8DDR_CS3_BIT     UINT32_C(1)
#define H8P8DDR_RFSH_BIT    UINT32_C(0)

#define H8P8DDR_CS0         H8_BITNO_TO_BITPTN(H8P8DDR_CS0_BIT)
#define H8P8DDR_CS1         H8_BITNO_TO_BITPTN(H8P8DDR_CS1_BIT)
#define H8P8DDR_CS2         H8_BITNO_TO_BITPTN(H8P8DDR_CS2_BIT)
#define H8P8DDR_CS3         H8_BITNO_TO_BITPTN(H8P8DDR_CS3_BIT)
#define H8P8DDR_RFSH		H8_BITNO_TO_BITPTN(H8P8DDR_RFSH_BIT)

#define H8P8DDR_IRQ3_BIT    UINT32_C(3)
#define H8P8DDR_IRQ2_BIT    UINT32_C(2)
#define H8P8DDR_IRQ1_BIT    UINT32_C(1)
#define H8P8DDR_IRQ0_BIT    UINT32_C(0)

#define H8P8DDR_IRQ3        H8_BITNO_TO_BITPTN(H8P8DDR_IRQ3_BIT)
#define H8P8DDR_IRQ2        H8_BITNO_TO_BITPTN(H8P8DDR_IRQ2_BIT)
#define H8P8DDR_IRQ1        H8_BITNO_TO_BITPTN(H8P8DDR_IRQ1_BIT)
#define H8P8DDR_IRQ0        H8_BITNO_TO_BITPTN(H8P8DDR_IRQ0_BIT)

/* port9 (SCI) */

#define H8P9DDR             UINT32_C(0xffffd0)
#define H8P9DR              UINT32_C(0xffffd2)

#define H8P9DDR_SCK1_BIT    UINT32_C(5)
#define H8P9DDR_SCK0_BIT    UINT32_C(4)
#define H8P9DDR_RXD1_BIT    UINT32_C(3)
#define H8P9DDR_RXD0_BIT    UINT32_C(2)
#define H8P9DDR_TXD1_BIT    UINT32_C(1)
#define H8P9DDR_TXD0_BIT    UINT32_C(0)

#define H8P9DDR_SCK1        H8_BITNO_TO_BITPTN(H8P9DDR_SCK1_BIT)
#define H8P9DDR_SCK0        H8_BITNO_TO_BITPTN(H8P9DDR_SCK0_BIT)
#define H8P9DDR_RXD1        H8_BITNO_TO_BITPTN(H8P9DDR_RXD1_BIT)
#define H8P9DDR_RXD0        H8_BITNO_TO_BITPTN(H8P9DDR_RXD0_BIT)
#define H8P9DDR_TXD1        H8_BITNO_TO_BITPTN(H8P9DDR_TXD1_BIT)
#define H8P9DDR_TXD0        H8_BITNO_TO_BITPTN(H8P9DDR_TXD0_BIT)

#define H8P9DDR_IRQ5_BIT    UINT32_C(5)
#define H8P9DDR_IRQ4_BIT    UINT32_C(4)

#define H8P9DDR_IRQ5        H8_BITNO_TO_BITPTN(H8P9DDR_IRQ5_BIT)
#define H8P9DDR_IRQ4        H8_BITNO_TO_BITPTN(H8P9DDR_IRQ4_BIT)

/* portA (TPC/ITU/DMA) */

#define H8PADDR             UINT32_C(0xffffd1)
#define H8PADR              UINT32_C(0xffffd3)

#define H8PADDR_TP7_BIT     UINT32_C(7)
#define H8PADDR_TP6_BIT     UINT32_C(6)
#define H8PADDR_TP5_BIT     UINT32_C(5)
#define H8PADDR_TP4_BIT     UINT32_C(4)
#define H8PADDR_TP3_BIT     UINT32_C(3)
#define H8PADDR_TP2_BIT     UINT32_C(2)
#define H8PADDR_TP1_BIT     UINT32_C(1)
#define H8PADDR_TP0_BIT     UINT32_C(0)

#define H8PADDR_TP7         H8_BITNO_TO_BITPTN(H8PADDR_TP7_BIT)
#define H8PADDR_TP6         H8_BITNO_TO_BITPTN(H8PADDR_TP6_BIT)
#define H8PADDR_TP5         H8_BITNO_TO_BITPTN(H8PADDR_TP5_BIT)
#define H8PADDR_TP4         H8_BITNO_TO_BITPTN(H8PADDR_TP4_BIT)
#define H8PADDR_TP3         H8_BITNO_TO_BITPTN(H8PADDR_TP3_BIT)
#define H8PADDR_TP2         H8_BITNO_TO_BITPTN(H8PADDR_TP2_BIT)
#define H8PADDR_TP1         H8_BITNO_TO_BITPTN(H8PADDR_TP1_BIT)
#define H8PADDR_TP0         H8_BITNO_TO_BITPTN(H8PADDR_TP0_BIT)

#define H8PADDR_TIOCB2_BIT  UINT32_C(7)
#define H8PADDR_TIOCA2_BIT  UINT32_C(6)
#define H8PADDR_TIOCB1_BIT  UINT32_C(5)
#define H8PADDR_TIOCA1_BIT  UINT32_C(4)
#define H8PADDR_TIOCB0_BIT  UINT32_C(3)
#define H8PADDR_TIOCA0_BIT  UINT32_C(2)

#define H8PADDR_TIOCB2      H8_BITNO_TO_BITPTN(H8PADDR_TIOCB2_BIT)
#define H8PADDR_TIOCA2      H8_BITNO_TO_BITPTN(H8PADDR_TIOCA2_BIT)
#define H8PADDR_TIOCB1      H8_BITNO_TO_BITPTN(H8PADDR_TIOCB1_BIT)
#define H8PADDR_TIOCA1      H8_BITNO_TO_BITPTN(H8PADDR_TIOCA1_BIT)
#define H8PADDR_TIOCB0      H8_BITNO_TO_BITPTN(H8PADDR_TIOCB0_BIT)
#define H8PADDR_TIOCA0      H8_BITNO_TO_BITPTN(H8PADDR_TIOCA0_BIT)

#define H8PADDR_TEND1_BIT   UINT32_C(1)
#define H8PADDR_TEND0_BIT   UINT32_C(0)

#define H8PADDR_TEND1       H8_BITNO_TO_BITPTN(H8PADDR_TEND1_BIT)
#define H8PADDR_TEND0       H8_BITNO_TO_BITPTN(H8PADDR_TEND0_BIT)

#define H8PADDR_A20_BIT     UINT32_C(7)
#define H8PADDR_A21_BIT     UINT32_C(6)
#define H8PADDR_A22_BIT     UINT32_C(5)
#define H8PADDR_A23_BIT     UINT32_C(4)

#define H8PADDR_A20         H8_BITNO_TO_BITPTN(H8PADDR_A20_BIT)
#define H8PADDR_A21         H8_BITNO_TO_BITPTN(H8PADDR_A21_BIT)
#define H8PADDR_A22         H8_BITNO_TO_BITPTN(H8PADDR_A22_BIT)
#define H8PADDR_A23         H8_BITNO_TO_BITPTN(H8PADDR_A23_BIT)

#define H8PADDR_CS4_BIT     UINT32_C(6)
#define H8PADDR_CS5_BIT     UINT32_C(5)
#define H8PADDR_CS6_BIT     UINT32_C(4)

#define H8PADDR_CS4         H8_BITNO_TO_BITPTN(H8PADDR_CS4_BIT)
#define H8PADDR_CS5         H8_BITNO_TO_BITPTN(H8PADDR_CS5_BIT)
#define H8PADDR_CS6         H8_BITNO_TO_BITPTN(H8PADDR_CS6_BIT)

#define H8PADDR_TCLKD_BIT   UINT32_C(3)
#define H8PADDR_TCLKC_BIT   UINT32_C(2)
#define H8PADDR_TCLKB_BIT   UINT32_C(1)
#define H8PADDR_TCLKA_BIT   UINT32_C(0)

#define H8PADDR_TCLKD       H8_BITNO_TO_BITPTN(H8PADDR_TCLKD_BIT)
#define H8PADDR_TCLKC       H8_BITNO_TO_BITPTN(H8PADDR_TCLKC_BIT)
#define H8PADDR_TCLKB       H8_BITNO_TO_BITPTN(H8PADDR_TCLKB_BIT)
#define H8PADDR_TCLKA       H8_BITNO_TO_BITPTN(H8PADDR_TCLKA_BIT)

/* portB (TP/ITU/DMA/AD) */

#define H8PBDDR             UINT32_C(0xffffd4)
#define H8PBDR              UINT32_C(0xffffd6)

#define H8PBDDR_TP15_BIT    UINT32_C(7)
#define H8PBDDR_TP14_BIT    UINT32_C(6)
#define H8PBDDR_TP13_BIT    UINT32_C(5)
#define H8PBDDR_TP12_BIT    UINT32_C(4)
#define H8PBDDR_TP11_BIT    UINT32_C(3)
#define H8PBDDR_TP10_BIT    UINT32_C(2)
#define H8PBDDR_TP9_BIT     UINT32_C(1)
#define H8PBDDR_TP8_BIT     UINT32_C(0)

#define H8PBDDR_TP15        H8_BITNO_TO_BITPTN(H8PBDDR_TP15_BIT)
#define H8PBDDR_TP14        H8_BITNO_TO_BITPTN(H8PBDDR_TP14_BIT)
#define H8PBDDR_TP13        H8_BITNO_TO_BITPTN(H8PBDDR_TP13_BIT)
#define H8PBDDR_TP12        H8_BITNO_TO_BITPTN(H8PBDDR_TP12_BIT)
#define H8PBDDR_TP11        H8_BITNO_TO_BITPTN(H8PBDDR_TP11_BIT)
#define H8PBDDR_TP10        H8_BITNO_TO_BITPTN(H8PBDDR_TP10_BIT)
#define H8PBDDR_TP9         H8_BITNO_TO_BITPTN(H8PBDDR_TP9_BIT)
#define H8PBDDR_TP8         H8_BITNO_TO_BITPTN(H8PBDDR_TP8_BIT)

#define H8PBDDR_DREQ1_BIT   UINT32_C(7)
#define H8PBDDR_DREQ0_BIT   UINT32_C(6)

#define H8PBDDR_DREQ1       H8_BITNO_TO_BITPTN(H8PBDDR_DREQ1_BIT)
#define H8PBDDR_DREQ0       H8_BITNO_TO_BITPTN(H8PBDDR_DREQ0_BIT)

#define H8PBDDR_TOCXB4_BIT	UINT32_C(5)
#define H8PBDDR_TOCXA4_BIT	UINT32_C(4)
#define H8PBDDR_TIOCB4_BIT	UINT32_C(3)
#define H8PBDDR_TIOCA4_BIT	UINT32_C(2)
#define H8PBDDR_TIOCB3_BIT	UINT32_C(1)
#define H8PBDDR_TIOCA3_BIT	UINT32_C(0)

#define H8PBDDR_TOCXB4      H8_BITNO_TO_BITPTN(H8PBDDR_TOCXB4_BIT)
#define H8PBDDR_TOCXA4      H8_BITNO_TO_BITPTN(H8PBDDR_TOCXA4_BIT)
#define H8PBDDR_TIOCB4      H8_BITNO_TO_BITPTN(H8PBDDR_TIOCB4_BIT)
#define H8PBDDR_TIOCA4      H8_BITNO_TO_BITPTN(H8PBDDR_TIOCA4_BIT)
#define H8PBDDR_TIOCB3      H8_BITNO_TO_BITPTN(H8PBDDR_TIOCB3_BIT)
#define H8PBDDR_TIOCA3      H8_BITNO_TO_BITPTN(H8PBDDR_TIOCA3_BIT)

#define H8PBDDR_ADTRG_BIT   UINT32_C(7)

#define H8PBDDR_ADTRG       H8_BITNO_TO_BITPTN(H8PBDDR_ADTRG_BIT)

#define H8PBDDR_CS7_BIT     UINT32_C(6)

#define H8PBDDR_CS7         H8_BITNO_TO_BITPTN(H8PBDDR_CS7_BIT)

/* Interrupt Contolller */

#define H8ISCR              UINT32_C(0xfffff4)
#define H8IER               UINT32_C(0xfffff5)
#define H8ISR               UINT32_C(0xfffff6)
#define H8IPRA              UINT32_C(0xfffff8)
#define H8IPRB              UINT32_C(0xfffff9)

/* System Control Register */

#define H8SYSCR             UINT32_C(0xfffff2)
#define H8SYSCR_SSBY_BIT    UINT32_C(7)
#define H8SYSCR_STS2_BIT    UINT32_C(6)
#define H8SYSCR_STS1_BIT    UINT32_C(5)
#define H8SYSCR_STS0_BIT    UINT32_C(4)
#define H8SYSCR_UE_BIT      UINT32_C(3)
#define H8SYSCR_NMIEG_BIT   UINT32_C(2)
#define H8SYSCR_RAME_BIT    UINT32_C(0)

#define H8SYSCR_SSBY        H8_BITNO_TO_BITPTN(H8SYSCR_SSBY_BIT)
#define H8SYSCR_STS2        H8_BITNO_TO_BITPTN(H8SYSCR_STS2_BIT)
#define H8SYSCR_STS1        H8_BITNO_TO_BITPTN(H8SYSCR_STS1_BIT)
#define H8SYSCR_STS0        H8_BITNO_TO_BITPTN(H8SYSCR_STS0_BIT)
#define H8SYSCR_UE          H8_BITNO_TO_BITPTN(H8SYSCR_UE_BIT)
#define H8SYSCR_NMIEG       H8_BITNO_TO_BITPTN(H8SYSCR_NMIEG_BIT)
#define H8SYSCR_RAME        H8_BITNO_TO_BITPTN(H8SYSCR_RAME_BIT)

/* Interrupt Priority Register A */

#define H8IPR_IRQ0_BIT      UINT32_C(7)	/* IRQ0		*/
#define H8IPR_IRQ1_BIT      UINT32_C(6)	/* IRQ1		*/
#define H8IPR_IRQ2_BIT      UINT32_C(5)	/* IRQ2		*/
#define H8IPR_IRQ3_BIT      UINT32_C(5)	/* IRQ3		*/
#define H8IPR_IRQ4_BIT      UINT32_C(4)	/* IRQ4		*/
#define H8IPR_IRQ5_BIT      UINT32_C(4)	/* IRQ5		*/
#define H8IPR_WDT_BIT       UINT32_C(3)	/* WDT		*/
#define H8IPR_CMI_BIT       UINT32_C(3)	/* CMI		*/
#define H8IPR_ITU0_BIT      UINT32_C(2)	/* ITU0		*/
#define H8IPR_ITU1_BIT      UINT32_C(1)	/* ITU1		*/
#define H8IPR_ITU2_BIT      UINT32_C(0)	/* ITU2		*/

#define H8IPR_IRQ0          H8_BITNO_TO_BITPTN(H8IPR_IRQ0_BIT)
#define H8IPR_IRQ1          H8_BITNO_TO_BITPTN(H8IPR_IRQ1_BIT)
#define H8IPR_IRQ2          H8_BITNO_TO_BITPTN(H8IPR_IRQ2_BIT)
#define H8IPR_IRQ3          H8_BITNO_TO_BITPTN(H8IPR_IRQ3_BIT)
#define H8IPR_IRQ4          H8_BITNO_TO_BITPTN(H8IPR_IRQ4_BIT)
#define H8IPR_IRQ5          H8_BITNO_TO_BITPTN(H8IPR_IRQ5_BIT)
#define H8IPR_WDT           H8_BITNO_TO_BITPTN(H8IPR_WDT_BIT)
#define H8IPR_CMI           H8_BITNO_TO_BITPTN(H8IPR_CMI_BIT)
#define H8IPR_ITU0          H8_BITNO_TO_BITPTN(H8IPR_ITU0_BIT)
#define H8IPR_ITU1          H8_BITNO_TO_BITPTN(H8IPR_ITU1_BIT)
#define H8IPR_ITU2          H8_BITNO_TO_BITPTN(H8IPR_ITU2_BIT)

/* Interrupt Priority Register B */

#define H8IPR_ITU3_BIT      UINT32_C(7)	/* ITU3		*/
#define H8IPR_ITU4_BIT      UINT32_C(6)	/* ITU4		*/
#define H8IPR_DMAC_BIT      UINT32_C(5)	/* DMAC (CH0,1)	*/
#define H8IPR_SCI0_BIT      UINT32_C(3)	/* SCI0		*/
#define H8IPR_SCI1_BIT      UINT32_C(2)	/* SCI1		*/
#define H8IPR_AD_BIT        UINT32_C(1)	/* A/D		*/

#define H8IPR_ITU3          H8_BITNO_TO_BITPTN(H8IPR_ITU3_BIT)
#define H8IPR_ITU4          H8_BITNO_TO_BITPTN(H8IPR_ITU4_BIT)
#define H8IPR_DMAC          H8_BITNO_TO_BITPTN(H8IPR_DMAC_BIT)
#define H8IPR_SCI0          H8_BITNO_TO_BITPTN(H8IPR_SCI0_BIT)
#define H8IPR_SCI1          H8_BITNO_TO_BITPTN(H8IPR_SCI1_BIT)
#define H8IPR_AD            H8_BITNO_TO_BITPTN(H8IPR_AD_BIT)

/*	Bus Release Control Regisger	*/

#define H8BRCR              UINT32_C(0xfffff3)

/*	Control bit in BRCR		*/

#define H8BRCR_A23E_BIT     UINT32_C(7)
#define H8BRCR_A22E_BIT     UINT32_C(6)
#define H8BRCR_A21E_BIT     UINT32_C(5)
#define H8BRCR_BRLE_BIT     UINT32_C(1)

#define H8BRCR_A23E         H8_BITNO_TO_BITPTN(H8BRCR_A23E_BIT)
#define H8BRCR_A22E         H8_BITNO_TO_BITPTN(H8BRCR_A22E_BIT)
#define H8BRCR_A21E         H8_BITNO_TO_BITPTN(H8BRCR_A21E_BIT)
#define H8BRCR_BRLE         H8_BITNO_TO_BITPTN(H8BRCR_BRLE_BIT)

/* Integrated Timer Unit (ITU) */

#define TOPPERS_H8_ITU

#define H8ITU_TSTR          UINT32_C(0xffff60)
#define H8ITU_TSNC          UINT32_C(0xffff61)
#define H8ITU_TMDR          UINT32_C(0xffff62)
#define H8ITU_TFCR          UINT32_C(0xffff63)
#define H8ITU_TOER          UINT32_C(0xffff90)
#define H8ITU_TOCR          UINT32_C(0xffff91)

#define H8ITU0              UINT32_C(0xffff64)	/* base address */
#define H8ITU1              UINT32_C(0xffff6e)
#define H8ITU2              UINT32_C(0xffff78)
#define H8ITU3              UINT32_C(0xffff82)
#define H8ITU4              UINT32_C(0xffff92)

/* Integrated Timer Unit (ITU) */

/* address offset */

#define H8TCR               UINT32_C(0)
#define H8TIOR              UINT32_C(1)
#define H8TIER              UINT32_C(2)
#define H8TSR               UINT32_C(3)
#define H8TCNT              UINT32_C(4)
#define H8TCNTH             UINT32_C(4)
#define H8TCNTL             UINT32_C(5)
#define H8GRA               UINT32_C(6)
#define H8GRAH              UINT32_C(6)
#define H8GRAL              UINT32_C(7)
#define H8GRB               UINT32_C(8)
#define H8GRBH              UINT32_C(8)
#define H8GRBL              UINT32_C(9)
#define H8BRA               UINT32_C(10)
#define H8BRAH              UINT32_C(10)
#define H8BRAL              UINT32_C(11)
#define H8BRB               UINT32_C(12)
#define H8BRBH              UINT32_C(12)
#define H8BRBL              UINT32_C(13)

/* ITU Timer Start Register (TSTR) */

#define H8TSTR_STR4_BIT     UINT32_C(4)
#define H8TSTR_STR3_BIT     UINT32_C(3)
#define H8TSTR_STR2_BIT     UINT32_C(2)
#define H8TSTR_STR1_BIT     UINT32_C(1)
#define H8TSTR_STR0_BIT     UINT32_C(0)

#define H8TSTR_STR4         H8_BITNO_TO_BITPTN(H8TSTR_STR4_BIT)
#define H8TSTR_STR3         H8_BITNO_TO_BITPTN(H8TSTR_STR3_BIT)
#define H8TSTR_STR2         H8_BITNO_TO_BITPTN(H8TSTR_STR2_BIT)
#define H8TSTR_STR1         H8_BITNO_TO_BITPTN(H8TSTR_STR1_BIT)
#define H8TSTR_STR0         H8_BITNO_TO_BITPTN(H8TSTR_STR0_BIT)

/* ITU Timer Control Register (TCR) */

#define H8TCR_CCLR1_BIT     UINT32_C(6)
#define H8TCR_CCLR0_BIT     UINT32_C(5)
#define H8TCR_CKEG1_BIT     UINT32_C(4)
#define H8TCR_CKEG0_BIT     UINT32_C(3)
#define H8TCR_TPSC2_BIT     UINT32_C(2)
#define H8TCR_TPSC1_BIT     UINT32_C(1)
#define H8TCR_TPSC0_BIT     UINT32_C(0)

#define H8TCR_CCLR1         H8_BITNO_TO_BITPTN(H8TCR_CCLR1_BIT)
#define H8TCR_CCLR0         H8_BITNO_TO_BITPTN(H8TCR_CCLR0_BIT)
#define H8TCR_CKEG1         H8_BITNO_TO_BITPTN(H8TCR_CKEG1_BIT)
#define H8TCR_CKEG0         H8_BITNO_TO_BITPTN(H8TCR_CKEG0_BIT)
#define H8TCR_TPSC2         H8_BITNO_TO_BITPTN(H8TCR_TPSC2_BIT)
#define H8TCR_TPSC1         H8_BITNO_TO_BITPTN(H8TCR_TPSC1_BIT)
#define H8TCR_TPSC0         H8_BITNO_TO_BITPTN(H8TCR_TPSC0_BIT)

/* ITU Timer Status Register (TSR) */

#define H8TSR_OVIF_BIT      UINT32_C(2)
#define H8TSR_IMIFB_BIT     UINT32_C(1)
#define H8TSR_IMIFA_BIT     UINT32_C(0)

#define H8TSR_OVIF          H8_BITNO_TO_BITPTN(H8TSR_OVIF_BIT)
#define H8TSR_IMIFB         H8_BITNO_TO_BITPTN(H8TSR_IMIFB_BIT)
#define H8TSR_IMIFA         H8_BITNO_TO_BITPTN(H8TSR_IMIFA_BIT)

/* ITU Timer Intrrupt Enable Register (TIER) */

#define H8TIER_OVIE_BIT     UINT32_C(2)
#define H8TIER_IMIEB_BIT    UINT32_C(1)
#define H8TIER_IMIEA_BIT    UINT32_C(0)

#define H8TIER_OVIE         H8_BITNO_TO_BITPTN(H8TIER_OVIE_BIT)
#define H8TIER_IMIEB        H8_BITNO_TO_BITPTN(H8TIER_IMIEB_BIT)
#define H8TIER_IMIEA        H8_BITNO_TO_BITPTN(H8TIER_IMIEA_BIT)

/* ITU Timer I/O Control Register (TIOR) */

#define H8TIOR_IOB2_BIT     UINT32_C(6)
#define H8TIOR_IOB1_BIT     UINT32_C(5)
#define H8TIOR_IOB0_BIT     UINT32_C(4)
#define H8TIOR_IOA2_BIT     UINT32_C(2)
#define H8TIOR_IOA1_BIT     UINT32_C(1)
#define H8TIOR_IOA0_BIT     UINT32_C(0)

#define H8TIOR_IOB2         H8_BITNO_TO_BITPTN(H8TIOR_IOB2_BIT)
#define H8TIOR_IOB1         H8_BITNO_TO_BITPTN(H8TIOR_IOB1_BIT)
#define H8TIOR_IOB0         H8_BITNO_TO_BITPTN(H8TIOR_IOB0_BIT)
#define H8TIOR_IOA2         H8_BITNO_TO_BITPTN(H8TIOR_IOA2_BIT)
#define H8TIOR_IOA1         H8_BITNO_TO_BITPTN(H8TIOR_IOA1_BIT)
#define H8TIOR_IOA0         H8_BITNO_TO_BITPTN(H8TIOR_IOA0_BIT)

/* Serial Communication Interface (SCI) */

#define H8SCI0              UINT32_C(0xffffb0)	/* base address */
#define H8SCI1              UINT32_C(0xffffb8)

/* address offset */

#define H8SMR               UINT32_C(0)
#define H8BRR               UINT32_C(1)
#define H8SCR               UINT32_C(2)
#define H8TDR               UINT32_C(3)
#define H8SSR               UINT32_C(4)
#define H8RDR               UINT32_C(5)

/* SCI Serial Mode Register (SMR) */

#define H8SMR_CA_BIT        UINT32_C(7)
#define H8SMR_CHR_BIT       UINT32_C(6)
#define H8SMR_PE_BIT        UINT32_C(5)
#define H8SMR_OE_BIT        UINT32_C(4)
#define H8SMR_STOP_BIT      UINT32_C(3)
#define H8SMR_MP_BIT        UINT32_C(2)
#define H8SMR_CKS1_BIT      UINT32_C(1)
#define H8SMR_CKS0_BIT      UINT32_C(0)

#define H8SMR_CA            H8_BITNO_TO_BITPTN(H8SMR_CA_BIT)
#define H8SMR_CHR           H8_BITNO_TO_BITPTN(H8SMR_CHR_BIT)
#define H8SMR_PE            H8_BITNO_TO_BITPTN(H8SMR_PE_BIT)
#define H8SMR_OE            H8_BITNO_TO_BITPTN(H8SMR_OE_BIT)
#define H8SMR_STOP          H8_BITNO_TO_BITPTN(H8SMR_STOP_BIT)
#define H8SMR_MP            H8_BITNO_TO_BITPTN(H8SMR_MP_BIT)
#define H8SMR_CKS1          H8_BITNO_TO_BITPTN(H8SMR_CKS1_BIT)
#define H8SMR_CKS0          H8_BITNO_TO_BITPTN(H8SMR_CKS0_BIT)
#define H8SMR_CKS_MASK      (H8SMR_CKS1 | H8SMR_CKS0)

/* SCI Serial Control Register (SCR) */

#define H8SCR_TIE_BIT       UINT32_C(7)
#define H8SCR_RIE_BIT       UINT32_C(6)
#define H8SCR_TE_BIT        UINT32_C(5)
#define H8SCR_RE_BIT        UINT32_C(4)
#define H8SCR_MPIE_BIT      UINT32_C(3)
#define H8SCR_TEIE_BIT      UINT32_C(2)
#define H8SCR_CKE1_BIT      UINT32_C(1)
#define H8SCR_CKE0_BIT      UINT32_C(0)

#define H8SCR_TIE           H8_BITNO_TO_BITPTN(H8SCR_TIE_BIT)
#define H8SCR_RIE           H8_BITNO_TO_BITPTN(H8SCR_RIE_BIT)
#define H8SCR_TE            H8_BITNO_TO_BITPTN(H8SCR_TE_BIT)
#define H8SCR_RE            H8_BITNO_TO_BITPTN(H8SCR_RE_BIT)
#define H8SCR_MPIE          H8_BITNO_TO_BITPTN(H8SCR_MPIE_BIT)
#define H8SCR_TEIE          H8_BITNO_TO_BITPTN(H8SCR_TEIE_BIT)
#define H8SCR_CKE1          H8_BITNO_TO_BITPTN(H8SCR_CKE1_BIT)
#define H8SCR_CKE0          H8_BITNO_TO_BITPTN(H8SCR_CKE0_BIT)
#define H8SCR_CKE_MASK      (H8SCR_CKE1 | H8SCR_CKE0)
#define H8SCR_IE            (H8SCR_TIE | H8SCR_RIE | H8SCR_MPIE | H8SCR_TEIE)

/* SCI Serial Status Register (SSR) */

#define H8SSR_TDRE_BIT      UINT32_C(7)
#define H8SSR_RDRF_BIT      UINT32_C(6)
#define H8SSR_ORER_BIT      UINT32_C(5)
#define H8SSR_FER_BIT       UINT32_C(4)
#define H8SSR_PER_BIT       UINT32_C(3)
#define H8SSR_TEND_BIT      UINT32_C(2)
#define H8SSR_MPB_BIT       UINT32_C(1)
#define H8SSR_MPBT_BIT      UINT32_C(0)

#define H8SSR_TDRE          H8_BITNO_TO_BITPTN(H8SSR_TDRE_BIT)
#define H8SSR_RDRF          H8_BITNO_TO_BITPTN(H8SSR_RDRF_BIT)
#define H8SSR_ORER          H8_BITNO_TO_BITPTN(H8SSR_ORER_BIT)
#define H8SSR_FER           H8_BITNO_TO_BITPTN(H8SSR_FER_BIT)
#define H8SSR_PER           H8_BITNO_TO_BITPTN(H8SSR_PER_BIT)
#define H8SSR_TEND          H8_BITNO_TO_BITPTN(H8SSR_TEND_BIT)
#define H8SSR_MPB           H8_BITNO_TO_BITPTN(H8SSR_MPB_BIT)
#define H8SSR_MPBT          H8_BITNO_TO_BITPTN(H8SSR_MPBT_BIT)

/*
 *  ¢
 */

#define H8IN_ROM_BASE       UINT32_C(0x000000)
#define H8IN_ROM_SIZE       UINT32_C(0x020000)
#define H8IN_RAM_BASE       UINT32_C(0xffef10)
#define H8IN_RAM_SIZE       UINT32_C(0x001000)

#endif /* TOPPERS_H8_3048F_H_ */
