/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2007 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Kunihiko Ohnaka
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: h8_3069f.h,v 1.4 2008/05/24 18:25:15 roi Exp $
 */

#ifndef TOPPERS_H8_3069F_H_
#define TOPPERS_H8_3069F_H_

/*
 *  H8/3069F 
 */

/*  ֹκ  */
#define TMAX_INTNO			64U

/*  IRQֹ(intno)κ/Ǿ  */
#define TMAX_INTNO_IRQ		17U
#define TMIN_INTNO_IRQ		12U

/*  IRQֹκ  */
#define TMAX_IRQ_NO			5U

/*  IPRA쥸ǳߥ٥Ǥֹκ  */
#define TMAX_INTNO_IPRA		34U




/* Interrupt numbers */

#define TINTNO_NMI			 7U		/* NMI */

#define TINTNO_TRAP8		 8U

#define TINTNO_IRQ0			12U		/* IRQ0 */
#define TINTNO_IRQ1			13U		/* IRQ1 */
#define TINTNO_IRQ2			14U		/* IRQ2 */
#define TINTNO_IRQ3			15U		/* IRQ3 */
#define TINTNO_IRQ4			16U		/* IRQ4 */
#define TINTNO_IRQ5			17U		/* IRQ5 */

#define TINTNO_WOVI         20U     /* Watch Doc Timer */

#define TINTNO_CMI          21U     /* Compare Match */

#define TINTNO_ADI			23U		/* A/D */

#define TINTNO_IMIA0        24U     /* ITU0 IMIA0 */
#define TINTNO_IMIB0        25U     /* ITU0 IMIB0 */
#define TINTNO_OVI0         26U     /* ITU0 OVI0  */

#define TINTNO_IMIA1        28U     /* ITU1 IMIA1 */
#define TINTNO_IMIB1        29U     /* ITU1 IMIB1 */
#define TINTNO_OVI1         30U     /* ITU1 OVI1  */

#define TINTNO_IMIA2        32U     /* ITU2 IMIA2 */
#define TINTNO_IMIB2        33U     /* ITU2 IMIB2 */
#define TINTNO_OVI2         34U     /* ITU2 OVI2  */

#define TINTNO_CIMIA0		36U		/* 8 bit timer 0 CIMIA0 */
#define TINTNO_CIMIB0		37U		/* 8 bit timer 0 CIMIB0 */
#define TINTNO_CIMIA1		38U		/* 8 bit timer 1 CIMIA1 */
#define TINTNO_CIMIB1		38U		/* 8 bit timer 1 CIMIB1 */
#define TINTNO_TOVI0		39U		/* 8 bit timer 0 TOVI0  */
#define TINTNO_TOVI1		39U		/* 8 bit timer 1 TOVI1  */

#define TINTNO_CIMIA2		40U		/* 8 bit timer 2 CIMIA2 */
#define TINTNO_CIMIB2		41U		/* 8 bit timer 2 CIMIB2 */
#define TINTNO_CIMIA3		42U		/* 8 bit timer 3 CIMIA3 */
#define TINTNO_CIMIB3		42U		/* 8 bit timer 3 CIMIB3 */
#define TINTNO_TOVI2		43U		/* 8 bit timer 2 TOVI2  */
#define TINTNO_TOVI3		43U		/* 8 bit timer 3 TOVI3  */

#define TINTNO_DEND0A       44U     /* DMAC */
#define TINTNO_DEND0B       45U     /* DMAC */
#define TINTNO_DEND1A       46U     /* DMAC */
#define TINTNO_DEND1B       47U     /* DMAC */

#define TINTNO_ERI0         52U     /* SCI0 ERI */
#define TINTNO_RXI0         53U     /* SCI0 RXI */
#define TINTNO_TXI0         54U     /* SCI0 TXI */
#define TINTNO_TEI0         55U     /* SCI0 TEI */

#define TINTNO_ERI1         56U     /* SCI1 ERI */
#define TINTNO_RXI1         57U     /* SCI1 RXI */
#define TINTNO_TXI1         58U     /* SCI1 TXI */
#define TINTNO_TEI1         59U     /* SCI1 TEI */

#define TINTNO_ERI2			60U		/* SCI2 ERI */
#define TINTNO_RXI2			61U		/* SCI2 RXI */
#define TINTNO_TXI2			62U		/* SCI2 TXI */
#define TINTNO_TEI2			63U		/* SCI2 TEI */


/* 
 * ӥåֹӥåȥѥѴޥ
 */
#define H8_BITNO_TO_BITPTN(no)  (UINT32_C(1) << (no))

/* 
 * register address 
 *I/O쥸(1) 0xee,00000xee,00ff
 *I/O쥸(2) 0xff,ff200xff,ffe9
 *ޥ˥奢ˤϲ2ХȤܤƤʤΤ
 *1ХȤ䤦
 */

/* I/O ports */

/* port1: A0  - A7  */

#define H8P1DDR             UINT32_C(0xfee000)
#define H8P1DR              UINT32_C(0xffffd0)

/* port2: A8  - A15 */

#define H8P2DDR             UINT32_C(0xfee001)
#define H8P2DR              UINT32_C(0xffffd1)
#define H8P2PCR             UINT32_C(0xfee03c)

/* port3: D8  - D15 */

#define H8P3DDR             UINT32_C(0xfee002)
#define H8P3DR              UINT32_C(0xffffd2)

/* port4: D0  - D7  */

#define H8P4DDR             UINT32_C(0xfee003)
#define H8P4DR              UINT32_C(0xffffd3)
#define H8P4PCR             UINT32_C(0xfee03e)

/* port5: A16 - A19 */

#define H8P5DDR             UINT32_C(0xfee004)
#define H8P5DR              UINT32_C(0xffffd4)
#define H8P5PCR             UINT32_C(0xfee03f)

#define H8P5DDR_A19_BIT     UINT32_C(3)
#define H8P5DDR_A18_BIT     UINT32_C(2)
#define H8P5DDR_A17_BIT     UINT32_C(1)
#define H8P5DDR_A16_BIT     UINT32_C(0)

#define H8P5DDR_A19         H8_BITNO_TO_BITPTN(H8P5DDR_A19_BIT)
#define H8P5DDR_A18         H8_BITNO_TO_BITPTN(H8P5DDR_A18_BIT)
#define H8P5DDR_A17         H8_BITNO_TO_BITPTN(H8P5DDR_A17_BIT)
#define H8P5DDR_A16         H8_BITNO_TO_BITPTN(H8P5DDR_A16_BIT)

/* port6 */

#define H8P6DDR             UINT32_C(0xfee005)
#define H8P6DR              UINT32_C(0xffffd5)

#define H8P6DDR_CLOCK_BIT   UINT32_C(7)
#define H8P6DDR_HWR_BIT     UINT32_C(6)
#define H8P6DDR_LWR_BIT     UINT32_C(5)
#define H8P6DDR_RD_BIT      UINT32_C(4)
#define H8P6DDR_AS_BIT      UINT32_C(3)
#define H8P6DDR_BACK_BIT    UINT32_C(2)
#define H8P6DDR_BREQ_BIT    UINT32_C(1)
#define H8P6DDR_WAIT_BIT    UINT32_C(0)

#define H8P6DDR_CLOCK       H8_BITNO_TO_BITPTN(H8P6DDR_CLOCK_BIT)
#define H8P6DDR_HWR         H8_BITNO_TO_BITPTN(H8P6DDR_HWR_BIT)
#define H8P6DDR_LWR         H8_BITNO_TO_BITPTN(H8P6DDR_LWR_BIT)
#define H8P6DDR_RD          H8_BITNO_TO_BITPTN(H8P6DDR_RD_BIT)
#define H8P6DDR_AS          H8_BITNO_TO_BITPTN(H8P6DDR_AS_BIT)
#define H8P6DDR_BACK        H8_BITNO_TO_BITPTN(H8P6DDR_BACK_BIT)
#define H8P6DDR_BREQ        H8_BITNO_TO_BITPTN(H8P6DDR_BREQ_BIT)
#define H8P6DDR_WAIT        H8_BITNO_TO_BITPTN(H8P6DDR_WAIT_BIT)

/* port7 */

#define H8P7DR              UINT32_C(0xffffd6)

/* port8 */

#define H8P8DDR             UINT32_C(0xfee007)
#define H8P8DR              UINT32_C(0xffffd7)

#define H8P8DDR_CS0_BIT     UINT32_C(4)
#define H8P8DDR_CS1_BIT     UINT32_C(3)
#define H8P8DDR_CS2_BIT     UINT32_C(2)
#define H8P8DDR_CS3_BIT     UINT32_C(1)
#define H8P8DDR_RFSH_BIT    UINT32_C(0)

#define H8P8DDR_CS0         H8_BITNO_TO_BITPTN(H8P8DDR_CS0_BIT)
#define H8P8DDR_CS1         H8_BITNO_TO_BITPTN(H8P8DDR_CS1_BIT)
#define H8P8DDR_CS2         H8_BITNO_TO_BITPTN(H8P8DDR_CS2_BIT)
#define H8P8DDR_CS3         H8_BITNO_TO_BITPTN(H8P8DDR_CS3_BIT)
#define H8P8DDR_RFSH        H8_BITNO_TO_BITPTN(H8P8DDR_RFSH_BIT)

#define H8P8DDR_IRQ3_BIT    UINT32_C(3)
#define H8P8DDR_IRQ2_BIT    UINT32_C(2)
#define H8P8DDR_IRQ1_BIT    UINT32_C(1)
#define H8P8DDR_IRQ0_BIT    UINT32_C(0)

#define H8P8DDR_IRQ3        H8_BITNO_TO_BITPTN(H8P8DDR_IRQ3_BIT)
#define H8P8DDR_IRQ2        H8_BITNO_TO_BITPTN(H8P8DDR_IRQ2_BIT)
#define H8P8DDR_IRQ1        H8_BITNO_TO_BITPTN(H8P8DDR_IRQ1_BIT)
#define H8P8DDR_IRQ0        H8_BITNO_TO_BITPTN(H8P8DDR_IRQ0_BIT)

#define H8P8DDR_ADTRG_BIT   UINT32_C(3)

#define H8P8DDR_ADTRG       H8_BITNO_TO_BITPTN(H8PBDDR_ADTRG_BIT)

/* port9 (SCI) */

#define H8P9DDR             UINT32_C(0xfee008)
#define H8P9DR              UINT32_C(0xffffd8)

#define H8P9DDR_SCK1_BIT    UINT32_C(5)
#define H8P9DDR_SCK0_BIT    UINT32_C(4)
#define H8P9DDR_RXD1_BIT    UINT32_C(3)
#define H8P9DDR_RXD0_BIT    UINT32_C(2)
#define H8P9DDR_TXD1_BIT    UINT32_C(1)
#define H8P9DDR_TXD0_BIT    UINT32_C(0)

#define H8P9DDR_SCK1        H8_BITNO_TO_BITPTN(H8P9DDR_SCK1_BIT)
#define H8P9DDR_SCK0        H8_BITNO_TO_BITPTN(H8P9DDR_SCK0_BIT)
#define H8P9DDR_RXD1        H8_BITNO_TO_BITPTN(H8P9DDR_RXD1_BIT)
#define H8P9DDR_RXD0        H8_BITNO_TO_BITPTN(H8P9DDR_RXD0_BIT)
#define H8P9DDR_TXD1        H8_BITNO_TO_BITPTN(H8P9DDR_TXD1_BIT)
#define H8P9DDR_TXD0        H8_BITNO_TO_BITPTN(H8P9DDR_TXD0_BIT)

#define H8P9DDR_IRQ5_BIT    UINT32_C(5)
#define H8P9DDR_IRQ4_BIT    UINT32_C(4)

#define H8P9DDR_IRQ5        H8_BITNO_TO_BITPTN(H8P9DDR_IRQ5_BIT)
#define H8P9DDR_IRQ4        H8_BITNO_TO_BITPTN(H8P9DDR_IRQ4_BIT)

/* portA (TPC/ITU/DMA) */

#define H8PADDR             UINT32_C(0xfee009)
#define H8PADR              UINT32_C(0xffffd9)

#define H8PADDR_TP7_BIT     UINT32_C(7)
#define H8PADDR_TP6_BIT     UINT32_C(6)
#define H8PADDR_TP5_BIT     UINT32_C(5)
#define H8PADDR_TP4_BIT     UINT32_C(4)
#define H8PADDR_TP3_BIT     UINT32_C(3)
#define H8PADDR_TP2_BIT     UINT32_C(2)
#define H8PADDR_TP1_BIT     UINT32_C(1)
#define H8PADDR_TP0_BIT     UINT32_C(0)

#define H8PADDR_TP7         H8_BITNO_TO_BITPTN(H8PADDR_TP7_BIT)
#define H8PADDR_TP6         H8_BITNO_TO_BITPTN(H8PADDR_TP6_BIT)
#define H8PADDR_TP5         H8_BITNO_TO_BITPTN(H8PADDR_TP5_BIT)
#define H8PADDR_TP4         H8_BITNO_TO_BITPTN(H8PADDR_TP4_BIT)
#define H8PADDR_TP3         H8_BITNO_TO_BITPTN(H8PADDR_TP3_BIT)
#define H8PADDR_TP2         H8_BITNO_TO_BITPTN(H8PADDR_TP2_BIT)
#define H8PADDR_TP1         H8_BITNO_TO_BITPTN(H8PADDR_TP1_BIT)
#define H8PADDR_TP0         H8_BITNO_TO_BITPTN(H8PADDR_TP0_BIT)

#define H8PADDR_TIOCB2_BIT  UINT32_C(7)
#define H8PADDR_TIOCA2_BIT  UINT32_C(6)
#define H8PADDR_TIOCB1_BIT  UINT32_C(5)
#define H8PADDR_TIOCA1_BIT  UINT32_C(4)
#define H8PADDR_TIOCB0_BIT  UINT32_C(3)
#define H8PADDR_TIOCA0_BIT  UINT32_C(2)

#define H8PADDR_TIOCB2      H8_BITNO_TO_BITPTN(H8PADDR_TIOCB2_BIT)
#define H8PADDR_TIOCA2      H8_BITNO_TO_BITPTN(H8PADDR_TIOCA2_BIT)
#define H8PADDR_TIOCB1      H8_BITNO_TO_BITPTN(H8PADDR_TIOCB1_BIT)
#define H8PADDR_TIOCA1      H8_BITNO_TO_BITPTN(H8PADDR_TIOCA1_BIT)
#define H8PADDR_TIOCB0      H8_BITNO_TO_BITPTN(H8PADDR_TIOCB0_BIT)
#define H8PADDR_TIOCA0      H8_BITNO_TO_BITPTN(H8PADDR_TIOCA0_BIT)

#define H8PADDR_TEND1_BIT   UINT32_C(1)
#define H8PADDR_TEND0_BIT   UINT32_C(0)

#define H8PADDR_TEND1       H8_BITNO_TO_BITPTN(H8PADDR_TEND1_BIT)
#define H8PADDR_TEND0       H8_BITNO_TO_BITPTN(H8PADDR_TEND0_BIT)

#define H8PADDR_A20_BIT     UINT32_C(7)
#define H8PADDR_A21_BIT     UINT32_C(6)
#define H8PADDR_A22_BIT     UINT32_C(5)
#define H8PADDR_A23_BIT     UINT32_C(4)

#define H8PADDR_A20         H8_BITNO_TO_BITPTN(H8PADDR_A20_BIT)
#define H8PADDR_A21         H8_BITNO_TO_BITPTN(H8PADDR_A21_BIT)
#define H8PADDR_A22         H8_BITNO_TO_BITPTN(H8PADDR_A22_BIT)
#define H8PADDR_A23         H8_BITNO_TO_BITPTN(H8PADDR_A23_BIT)

#define H8PADDR_TCLKD_BIT   UINT32_C(3)
#define H8PADDR_TCLKC_BIT   UINT32_C(2)
#define H8PADDR_TCLKB_BIT   UINT32_C(1)
#define H8PADDR_TCLKA_BIT   UINT32_C(0)

#define H8PADDR_TCLKD       H8_BITNO_TO_BITPTN(H8PADDR_TCLKD_BIT)
#define H8PADDR_TCLKC       H8_BITNO_TO_BITPTN(H8PADDR_TCLKC_BIT)
#define H8PADDR_TCLKB       H8_BITNO_TO_BITPTN(H8PADDR_TCLKB_BIT)
#define H8PADDR_TCLKA       H8_BITNO_TO_BITPTN(H8PADDR_TCLKA_BIT)

/* portB (TP/ITU/DMA/AD) */

#define H8PBDDR             UINT32_C(0xfee00a)
#define H8PBDR              UINT32_C(0xffffda)

#define H8PBDDR_TP15_BIT    UINT32_C(7)
#define H8PBDDR_TP14_BIT    UINT32_C(6)
#define H8PBDDR_TP13_BIT    UINT32_C(5)
#define H8PBDDR_TP12_BIT    UINT32_C(4)
#define H8PBDDR_TP11_BIT    UINT32_C(3)
#define H8PBDDR_TP10_BIT    UINT32_C(2)
#define H8PBDDR_TP9_BIT     UINT32_C(1)
#define H8PBDDR_TP8_BIT     UINT32_C(0)

#define H8PBDDR_TP15        H8_BITNO_TO_BITPTN(H8PBDDR_TP15_BIT)
#define H8PBDDR_TP14        H8_BITNO_TO_BITPTN(H8PBDDR_TP14_BIT)
#define H8PBDDR_TP13        H8_BITNO_TO_BITPTN(H8PBDDR_TP13_BIT)
#define H8PBDDR_TP12        H8_BITNO_TO_BITPTN(H8PBDDR_TP12_BIT)
#define H8PBDDR_TP11        H8_BITNO_TO_BITPTN(H8PBDDR_TP11_BIT)
#define H8PBDDR_TP10        H8_BITNO_TO_BITPTN(H8PBDDR_TP10_BIT)
#define H8PBDDR_TP9         H8_BITNO_TO_BITPTN(H8PBDDR_TP9_BIT)
#define H8PBDDR_TP8         H8_BITNO_TO_BITPTN(H8PBDDR_TP8_BIT)

#define H8PBDDR_LCAS_BIT    UINT32_C(5)
#define H8PBDDR_UCAS_BIT    UINT32_C(4)
#define H8PBDDR_DREQ1_BIT   UINT32_C(3)
#define H8PBDDR_DREQ0_BIT   UINT32_C(1)

#define H8PBDDR_LCAS        H8_BITNO_TO_BITPTN(H8PBDDR_LCAS_BIT)
#define H8PBDDR_UCAS        H8_BITNO_TO_BITPTN(H8PBDDR_UCAS_BIT)
#define H8PBDDR_DREQ1       H8_BITNO_TO_BITPTN(H8PBDDR_DREQ1_BIT)
#define H8PBDDR_DREQ0       H8_BITNO_TO_BITPTN(H8PBDDR_DREQ0_BIT)

#define H8PBDDR_TMIO3_BIT   UINT32_C(3)
#define H8PBDDR_TMIO2_BIT   UINT32_C(2)
#define H8PBDDR_TMIO1_BIT   UINT32_C(1)
#define H8PBDDR_TMIO0_BIT   UINT32_C(0)

#define H8PBDDR_TMIO4       H8_BITNO_TO_BITPTN(H8PBDDR_TMIO3_BIT)
#define H8PBDDR_TMIO3       H8_BITNO_TO_BITPTN(H8PBDDR_TMIO2_BIT)
#define H8PBDDR_TMIO2       H8_BITNO_TO_BITPTN(H8PBDDR_TMIO1_BIT)
#define H8PBDDR_TMIO1       H8_BITNO_TO_BITPTN(H8PBDDR_TMIO0_BIT)

#define H8PBDDR_RXD2_BIT    UINT32_C(7)
#define H8PBDDR_TXD2_BIT    UINT32_C(6)
#define H8PBDDR_SCK2_BIT    UINT32_C(5)

#define H8PBDDR_RXD2        H8_BITNO_TO_BITPTN(H8PBDDR_RXD2_BIT)
#define H8PBDDR_TXD2        H8_BITNO_TO_BITPTN(H8PBDDR_TXD2_BIT)
#define H8PBDDR_SCK2        H8_BITNO_TO_BITPTN(H8PBDDR_SCK2_BIT)

#define H8PBDDR_CS4_BIT     UINT32_C(3)
#define H8PBDDR_CS5_BIT     UINT32_C(2)
#define H8PBDDR_CS6_BIT     UINT32_C(1)
#define H8PBDDR_CS7_BIT     UINT32_C(0)

#define H8PBDDR_CS4         H8_BITNO_TO_BITPTN(H8PBDDR_CS4_BIT)
#define H8PBDDR_CS5         H8_BITNO_TO_BITPTN(H8PBDDR_CS5_BIT)
#define H8PBDDR_CS6         H8_BITNO_TO_BITPTN(H8PBDDR_CS6_BIT)
#define H8PBDDR_CS7         H8_BITNO_TO_BITPTN(H8PBDDR_CS7_BIT)

/* Interrupt Contolller */

#define H8INTC              UINT32_C(0xfee014)  /* interrupt controller base address */
#define H8ISCR              UINT32_C(0xfee014)
#define H8IER               UINT32_C(0xfee015)
#define H8ISR               UINT32_C(0xfee016)
#define H8IPRA              UINT32_C(0xfee018)
#define H8IPRB              UINT32_C(0xfee019)

/* System Control Register */

#define H8SYSCR             UINT32_C(0xfee012)  /* SYSCR */

#define H8SYSCR_SSBY_BIT    UINT32_C(7)
#define H8SYSCR_STS2_BIT    UINT32_C(6)
#define H8SYSCR_STS1_BIT    UINT32_C(5)
#define H8SYSCR_STS0_BIT    UINT32_C(4)
#define H8SYSCR_UE_BIT      UINT32_C(3)
#define H8SYSCR_NMIEG_BIT   UINT32_C(2)
#define H8SYSCR_SSOE_BIT    UINT32_C(1)
#define H8SYSCR_RAME_BIT    UINT32_C(0)

#define H8SYSCR_SSBY        H8_BITNO_TO_BITPTN(H8SYSCR_SSBY_BIT)
#define H8SYSCR_STS2        H8_BITNO_TO_BITPTN(H8SYSCR_STS2_BIT)
#define H8SYSCR_STS1        H8_BITNO_TO_BITPTN(H8SYSCR_STS1_BIT)
#define H8SYSCR_STS0        H8_BITNO_TO_BITPTN(H8SYSCR_STS0_BIT)
#define H8SYSCR_UE          H8_BITNO_TO_BITPTN(H8SYSCR_UE_BIT)
#define H8SYSCR_NMIEG       H8_BITNO_TO_BITPTN(H8SYSCR_NMIEG_BIT)
#define H8SYSCR_SSOE        H8_BITNO_TO_BITPTN(H8SYSCR_SSOE_BIT)
#define H8SYSCR_RAME        H8_BITNO_TO_BITPTN(H8SYSCR_RAME_BIT)

/* Interrupt Enable Register */

#define H8IER_IRQ5E_BIT     UINT32_C(5)	/* IRQ5			*/
#define H8IER_IRQ4E_BIT     UINT32_C(4)	/* IRQ4			*/
#define H8IER_IRQ3E_BIT     UINT32_C(3)	/* IRQ3			*/
#define H8IER_IRQ2E_BIT     UINT32_C(2)	/* IRQ2			*/
#define H8IER_IRQ1E_BIT     UINT32_C(1)	/* IRQ1			*/
#define H8IER_IRQ0E_BIT     UINT32_C(0)	/* IRQ0			*/

/* Interrupt Priority Register A */

#define H8IPR_IRQ0_BIT      UINT32_C(7)	/* IRQ0			*/
#define H8IPR_IRQ1_BIT      UINT32_C(6)	/* IRQ1			*/
#define H8IPR_IRQ2_BIT      UINT32_C(5)	/* IRQ2			*/
#define H8IPR_IRQ3_BIT      UINT32_C(5)	/* IRQ3			*/
#define H8IPR_IRQ4_BIT      UINT32_C(4)	/* IRQ4			*/
#define H8IPR_IRQ5_BIT      UINT32_C(4)	/* IRQ5			*/
#define H8IPR_WDT_BIT       UINT32_C(3)	/* WDT			*/
#define H8IPR_AD_BIT        UINT32_C(3)	/* A/D			*/
#define H8IPR_CMI_BIT       UINT32_C(3)	/* CMI			*/
#define H8IPR_ITU0_BIT      UINT32_C(2)	/* 16 bit timer 0	*/
#define H8IPR_ITU1_BIT      UINT32_C(1)	/* 16 bit timer 1	*/
#define H8IPR_ITU2_BIT      UINT32_C(0)	/* 16 bit timer 2	*/

#define H8IPR_IRQ0          H8_BITNO_TO_BITPTN(H8IPR_IRQ0_BIT)
#define H8IPR_IRQ1          H8_BITNO_TO_BITPTN(H8IPR_IRQ1_BIT)
#define H8IPR_IRQ2          H8_BITNO_TO_BITPTN(H8IPR_IRQ2_BIT)
#define H8IPR_IRQ3          H8_BITNO_TO_BITPTN(H8IPR_IRQ3_BIT)
#define H8IPR_IRQ4          H8_BITNO_TO_BITPTN(H8IPR_IRQ4_BIT)
#define H8IPR_IRQ5          H8_BITNO_TO_BITPTN(H8IPR_IRQ5_BIT)
#define H8IPR_WDT           H8_BITNO_TO_BITPTN(H8IPR_WDT_BIT)
#define H8IPR_AD            H8_BITNO_TO_BITPTN(H8IPR_AD_BIT)
#define H8IPR_CMI           H8_BITNO_TO_BITPTN(H8IPR_CMI_BIT)
#define H8IPR_ITU0          H8_BITNO_TO_BITPTN(H8IPR_ITU0_BIT)
#define H8IPR_ITU1          H8_BITNO_TO_BITPTN(H8IPR_ITU1_BIT)
#define H8IPR_ITU2          H8_BITNO_TO_BITPTN(H8IPR_ITU2_BIT)

/*	Bus Release Control Regisger	*/

#define H8BRCR              UINT32_C(0xfee013)

/*	Control bit in BRCR		*/

#define H8BRCR_A23E_BIT     UINT32_C(7)
#define H8BRCR_A22E_BIT     UINT32_C(6)
#define H8BRCR_A21E_BIT     UINT32_C(5)
#define H8BRCR_BRLE_BIT     UINT32_C(1)

#define H8BRCR_A23E         H8_BITNO_TO_BITPTN(H8BRCR_A23E_BIT)
#define H8BRCR_A22E         H8_BITNO_TO_BITPTN(H8BRCR_A22E_BIT)
#define H8BRCR_A21E         H8_BITNO_TO_BITPTN(H8BRCR_A21E_BIT)
#define H8BRCR_BRLE         H8_BITNO_TO_BITPTN(H8BRCR_BRLE_BIT)

/* Interrupt Priority Register B */

#define H8IPR_TU80_BIT      UINT32_C(7)	/* 8 bit timer 0	*/
#define H8IPR_TU81_BIT      UINT32_C(6)	/* 8 bit timer 1	*/
#define H8IPR_DMAC_BIT      UINT32_C(5)	/* DMAC (CH0,1)		*/
#define H8IPR_SCI0_BIT      UINT32_C(3)	/* SCI0			*/
#define H8IPR_SCI1_BIT      UINT32_C(2)	/* SCI1			*/
#define H8IPR_SCI2_BIT      UINT32_C(1)	/* SCI2			*/

#define H8IPR_TU80          H8_BITNO_TO_BITPTN(H8IPR_TU80_BIT)
#define H8IPR_TU81          H8_BITNO_TO_BITPTN(H8IPR_TU81_BIT)
#define H8IPR_DMAC          H8_BITNO_TO_BITPTN(H8IPR_DMAC_BIT)
#define H8IPR_SCI0          H8_BITNO_TO_BITPTN(H8IPR_SCI0_BIT)
#define H8IPR_SCI1          H8_BITNO_TO_BITPTN(H8IPR_SCI1_BIT)
#define H8IPR_SCI2          H8_BITNO_TO_BITPTN(H8IPR_SCI2_BIT)

/* 16 bit Timer */
#define TOPPERS_H8_16TU

#define H816TU              UINT32_C(0xffff60)	/* base address */
#define H816TU_TSTR         UINT32_C(0xffff60)
#define H816TU_TSNC         UINT32_C(0xffff61)
#define H816TU_TMDR         UINT32_C(0xffff62)
#define H816TU_TOLR         UINT32_C(0xffff63)
#define H816TU_TISRA        UINT32_C(0xffff64)
#define H816TU_TISRB        UINT32_C(0xffff65)
#define H816TU_TISRC        UINT32_C(0xffff66)

#define H816TU0             UINT32_C(0xffff68)	/* base address */
#define H816TU1             UINT32_C(0xffff70)	/* base address */
#define H816TU2             UINT32_C(0xffff78)	/* base address */

/* address offset */

#define H8TCR               UINT32_C(0)
#define H8TIOR              UINT32_C(1)
#define H8TCNT              UINT32_C(2)
#define H8TCNTH             UINT32_C(2)
#define H8TCNTL             UINT32_C(3)
#define H8GRA               UINT32_C(4)
#define H8GRAH              UINT32_C(4)
#define H8GRAL              UINT32_C(5)
#define H8GRB               UINT32_C(6)
#define H8GRBH              UINT32_C(6)
#define H8GRBL              UINT32_C(7)

/* Timer Start Register (TSTR) */

#define H8TSTR_STR2_BIT     UINT32_C(2)
#define H8TSTR_STR1_BIT     UINT32_C(1)
#define H8TSTR_STR0_BIT     UINT32_C(0)

#define H8TSTR_STR2         H8_BITNO_TO_BITPTN(H8TSTR_STR2_BIT)
#define H8TSTR_STR1         H8_BITNO_TO_BITPTN(H8TSTR_STR1_BIT)
#define H8TSTR_STR0         H8_BITNO_TO_BITPTN(H8TSTR_STR0_BIT)

/* Timer Synchronous Register (TSNC) */

#define H8TSNC_SYNC2_BIT    UINT32_C(2)
#define H8TSNC_SYNC1_BIT    UINT32_C(1)
#define H8TSNC_SYNC0_BIT    UINT32_C(0)

#define H8TSNC_SYNC2        H8_BITNO_TO_BITPTN(H8TSNC_SYNC2_BIT)
#define H8TSNC_SYNC1        H8_BITNO_TO_BITPTN(H8TSNC_SYNC1_BIT)
#define H8TSNC_SYNC0        H8_BITNO_TO_BITPTN(H8TSNC_SYNC0_BIT)

/* Timer Mode Register (TMDR) */

#define H8TMDR_MDF_BIT      UINT32_C(6)
#define H8TMDR_FDIR_BIT     UINT32_C(5)
#define H8TMDR_PWM2_BIT     UINT32_C(2)
#define H8TMDR_PWM1_BIT     UINT32_C(1)
#define H8TMDR_PWM0_BIT     UINT32_C(0)

#define H8TMDR_MDF          H8_BITNO_TO_BITPTN(H8TMDR_MDF_BIT)
#define H8TMDR_FDIR         H8_BITNO_TO_BITPTN(H8TMDR_FDIR_BIT)
#define H8TMDR_PWM2         H8_BITNO_TO_BITPTN(H8TMDR_PWM2_BIT)
#define H8TMDR_PWM1         H8_BITNO_TO_BITPTN(H8TMDR_PWM1_BIT)
#define H8TMDR_PWM0         H8_BITNO_TO_BITPTN(H8TMDR_PWM0_BIT)

/* Timer Interrupt Status Register A (TISRA) */

#define H8TISRA_IMIEA2_BIT  UINT32_C(6)
#define H8TISRA_IMIEA1_BIT  UINT32_C(5)
#define H8TISRA_IMIEA0_BIT  UINT32_C(4)
#define H8TISRA_IMFA2_BIT   UINT32_C(2)
#define H8TISRA_IMFA1_BIT   UINT32_C(1)
#define H8TISRA_IMFA0_BIT   UINT32_C(0)

#define H8TISRA_IMIEA2      H8_BITNO_TO_BITPTN(H8TISRA_IMIEA2_BIT)
#define H8TISRA_IMIEA1      H8_BITNO_TO_BITPTN(H8TISRA_IMIEA1_BIT)
#define H8TISRA_IMIEA0      H8_BITNO_TO_BITPTN(H8TISRA_IMIEA0_BIT)
#define H8TISRA_IMFA2       H8_BITNO_TO_BITPTN(H8TISRA_IMFA2_BIT)
#define H8TISRA_IMFA1       H8_BITNO_TO_BITPTN(H8TISRA_IMFA1_BIT)
#define H8TISRA_IMFA0       H8_BITNO_TO_BITPTN(H8TISRA_IMFA0_BIT)

/* Timer Interrupt Status Register B (TISRB) */

#define H8TISRB_IMIEA2_BIT  UINT32_C(6)
#define H8TISRB_IMIEA1_BIT  UINT32_C(5)
#define H8TISRB_IMIEA0_BIT  UINT32_C(4)
#define H8TISRB_IMFA2_BIT   UINT32_C(2)
#define H8TISRB_IMFA1_BIT   UINT32_C(1)
#define H8TISRB_IMFA0_BIT   UINT32_C(0)

#define H8TISRB_IMIEA2      H8_BITNO_TO_BITPTN(H8TISRB_IMIEA2_BIT)
#define H8TISRB_IMIEA1      H8_BITNO_TO_BITPTN(H8TISRB_IMIEA1_BIT)
#define H8TISRB_IMIEA0      H8_BITNO_TO_BITPTN(H8TISRB_IMIEA0_BIT)
#define H8TISRB_IMFA2       H8_BITNO_TO_BITPTN(H8TISRB_IMFA2_BIT)
#define H8TISRB_IMFA1       H8_BITNO_TO_BITPTN(H8TISRB_IMFA1_BIT)
#define H8TISRB_IMFA0       H8_BITNO_TO_BITPTN(H8TISRB_IMFA0_BIT)

/* Timer Interrupt Status Register C (TISRC) */

#define H8TISRC_OVIEA2_BIT  UINT32_C(6)
#define H8TISRC_OVIEA1_BIT  UINT32_C(5)
#define H8TISRC_OVIEA0_BIT  UINT32_C(4)
#define H8TISRC_OVFA2_BIT   UINT32_C(2)
#define H8TISRC_OVFA1_BIT   UINT32_C(1)
#define H8TISRC_OVFA0_BIT   UINT32_C(0)

#define H8TISRC_OVIEA2      H8_BITNO_TO_BITPTN(H8TISRC_OVIEA2_BIT)
#define H8TISRC_OVIEA1      H8_BITNO_TO_BITPTN(H8TISRC_OVIEA1_BIT)
#define H8TISRC_OVIEA0      H8_BITNO_TO_BITPTN(H8TISRC_OVIEA0_BIT)
#define H8TISRC_OVFA2       H8_BITNO_TO_BITPTN(H8TISRC_OVFA2_BIT)
#define H8TISRC_OVFA1       H8_BITNO_TO_BITPTN(H8TISRC_OVFA1_BIT)
#define H8TISRC_OVFA0       H8_BITNO_TO_BITPTN(H8TISRC_OVFA0_BIT)

/* Timer Control Register (TCR) */

#define H8TCR_CCLR1_BIT     UINT32_C(6)
#define H8TCR_CCLR0_BIT     UINT32_C(5)
#define H8TCR_CKEG1_BIT     UINT32_C(4)
#define H8TCR_CKEG0_BIT     UINT32_C(3)
#define H8TCR_TPSC2_BIT     UINT32_C(2)
#define H8TCR_TPSC1_BIT     UINT32_C(1)
#define H8TCR_TPSC0_BIT     UINT32_C(0)

#define H8TCR_CCLR1         H8_BITNO_TO_BITPTN(H8TCR_CCLR1_BIT)
#define H8TCR_CCLR0         H8_BITNO_TO_BITPTN(H8TCR_CCLR0_BIT)
#define H8TCR_CKEG1         H8_BITNO_TO_BITPTN(H8TCR_CKEG1_BIT)
#define H8TCR_CKEG0         H8_BITNO_TO_BITPTN(H8TCR_CKEG0_BIT)
#define H8TCR_TPSC2         H8_BITNO_TO_BITPTN(H8TCR_TPSC2_BIT)
#define H8TCR_TPSC1         H8_BITNO_TO_BITPTN(H8TCR_TPSC1_BIT)
#define H8TCR_TPSC0         H8_BITNO_TO_BITPTN(H8TCR_TPSC0_BIT)

/* Timer I/O Control Register (TIOR) */

#define H8TIOR_IOB2_BIT     UINT32_C(6)
#define H8TIOR_IOB1_BIT     UINT32_C(5)
#define H8TIOR_IOB0_BIT     UINT32_C(4)
#define H8TIOR_IOA2_BIT     UINT32_C(2)
#define H8TIOR_IOA1_BIT     UINT32_C(1)
#define H8TIOR_IOA0_BIT     UINT32_C(0)

#define H8TIOR_IOB2         H8_BITNO_TO_BITPTN(H8TIOR_IOB2_BIT)
#define H8TIOR_IOB1         H8_BITNO_TO_BITPTN(H8TIOR_IOB1_BIT)
#define H8TIOR_IOB0         H8_BITNO_TO_BITPTN(H8TIOR_IOB0_BIT)
#define H8TIOR_IOA2         H8_BITNO_TO_BITPTN(H8TIOR_IOA2_BIT)
#define H8TIOR_IOA1         H8_BITNO_TO_BITPTN(H8TIOR_IOA1_BIT)
#define H8TIOR_IOA0         H8_BITNO_TO_BITPTN(H8TIOR_IOA0_BIT)

/* 8 bit Timer */

#define H88TU0              UINT32_C(0xffff80)	/* base address */
#define H88TU1              UINT32_C(0xffff81)
#define H88TU2              UINT32_C(0xffff90)
#define H88TU3              UINT32_C(0xffff91)

/* address offset */

#define H88TCR              UINT32_C(0)
#define H88TCSR             UINT32_C(2)
#define H88TCORA            UINT32_C(4)
#define H88TCORB            UINT32_C(6)
#define H88TCNT             UINT32_C(8)

/* 8 Bit Timer Control Register (8TCR) */

#define H88TCR_CMIEB_BIT    UINT32_C(7)
#define H88TCR_CMIEA_BIT    UINT32_C(6)
#define H88TCR_OVIE_BIT     UINT32_C(5)
#define H88TCR_CCLR1_BIT    UINT32_C(4)
#define H88TCR_CCLR0_BIT    UINT32_C(3)
#define H88TCR_CKS2_BIT     UINT32_C(2)
#define H88TCR_CKS1_BIT     UINT32_C(1)
#define H88TCR_CKS0_BIT     UINT32_C(0)

#define H88TCR_CMIEB        H8_BITNO_TO_BITPTN(H88TCR_CMIEB_BIT)
#define H88TCR_CMIEA        H8_BITNO_TO_BITPTN(H88TCR_CMIEA_BIT)
#define H88TCR_OVIE         H8_BITNO_TO_BITPTN(H88TCR_OVIE_BIT)
#define H88TCR_CCLR1        H8_BITNO_TO_BITPTN(H88TCR_CCLR1_BIT)
#define H88TCR_CCLR0        H8_BITNO_TO_BITPTN(H88TCR_CCLR0_BIT)
#define H88TCR_CKS2         H8_BITNO_TO_BITPTN(H88TCR_CKS2_BIT)
#define H88TCR_CKS1         H8_BITNO_TO_BITPTN(H88TCR_CKS1_BIT)
#define H88TCR_CKS0         H8_BITNO_TO_BITPTN(H88TCR_CKS0_BIT)

/* 8 Bit Timer Control/Status Register (8TCSR) */

#define H88TCSR_CMFB_BIT    UINT32_C(7)
#define H88TCSR_CMFA_BIT    UINT32_C(6)
#define H88TCSR_OVF_BIT     UINT32_C(5)
#define H88TCSR_ADTE_BIT    UINT32_C(4)
#define H88TCSR_ICE_BIT     UINT32_C(4)
#define H88TCSR_OIS3_BIT    UINT32_C(3)
#define H88TCSR_OIS2_BIT    UINT32_C(2)
#define H88TCSR_OS1_BIT     UINT32_C(1)
#define H88TCSR_OS0_BIT     UINT32_C(0)

#define H88TCSR_CMFB        H8_BITNO_TO_BITPTN(H88TCSR_CMFB_BIT)
#define H88TCSR_CMFA        H8_BITNO_TO_BITPTN(H88TCSR_CMFA_BIT)
#define H88TCSR_OVF         H8_BITNO_TO_BITPTN(H88TCSR_OVF_BIT)
#define H88TCSR_ADTE        H8_BITNO_TO_BITPTN(H88TCSR_ADTE_BIT)
#define H88TCSR_ICE         H8_BITNO_TO_BITPTN(H88TCSR_ICE_BIT)
#define H88TCSR_OIS3        H8_BITNO_TO_BITPTN(H88TCSR_OIS3_BIT)
#define H88TCSR_OIS2        H8_BITNO_TO_BITPTN(H88TCSR_OIS2_BIT)
#define H88TCSR_OS1         H8_BITNO_TO_BITPTN(H88TCSR_OS1_BIT)
#define H88TCSR_OS0         H8_BITNO_TO_BITPTN(H88TCSR_OS0_BIT)

/* Serial Communication Interface (SCI) */

#define H8SCI0              UINT32_C(0xffffb0)	/* base address */
#define H8SCI1              UINT32_C(0xffffb8)
#define H8SCI2              UINT32_C(0xffffc0)

/* address offset */

#define H8SMR               UINT32_C(0)
#define H8BRR               UINT32_C(1)
#define H8SCR               UINT32_C(2)
#define H8TDR               UINT32_C(3)
#define H8SSR               UINT32_C(4)
#define H8RDR               UINT32_C(5)
#define H8SCMR              UINT32_C(6)

/* SCI Serial Mode Register (SMR) */

#define H8SMR_GM_BIT        UINT32_C(7)
#define H8SMR_CHR_BIT       UINT32_C(6)
#define H8SMR_PE_BIT        UINT32_C(5)
#define H8SMR_OE_BIT        UINT32_C(4)
#define H8SMR_STOP_BIT      UINT32_C(3)
#define H8SMR_MP_BIT        UINT32_C(2)
#define H8SMR_CKS1_BIT      UINT32_C(1)
#define H8SMR_CKS0_BIT      UINT32_C(0)

#define H8SMR_GM            H8_BITNO_TO_BITPTN(H8SMR_GM_BIT)
#define H8SMR_CHR           H8_BITNO_TO_BITPTN(H8SMR_CHR_BIT)
#define H8SMR_PE            H8_BITNO_TO_BITPTN(H8SMR_PE_BIT)
#define H8SMR_OE            H8_BITNO_TO_BITPTN(H8SMR_OE_BIT)
#define H8SMR_STOP          H8_BITNO_TO_BITPTN(H8SMR_STOP_BIT)
#define H8SMR_MP            H8_BITNO_TO_BITPTN(H8SMR_MP_BIT)
#define H8SMR_CKS1          H8_BITNO_TO_BITPTN(H8SMR_CKS1_BIT)
#define H8SMR_CKS0          H8_BITNO_TO_BITPTN(H8SMR_CKS0_BIT)
#define H8SMR_CKS_MASK      (H8SMR_CKS1 | H8SMR_CKS0)

/* SCI Serial Control Register (SCR) */

#define H8SCR_TIE_BIT       UINT32_C(7)
#define H8SCR_RIE_BIT       UINT32_C(6)
#define H8SCR_TE_BIT        UINT32_C(5)
#define H8SCR_RE_BIT        UINT32_C(4)
#define H8SCR_MPIE_BIT      UINT32_C(3)
#define H8SCR_TEIE_BIT      UINT32_C(2)
#define H8SCR_CKE1_BIT      UINT32_C(1)
#define H8SCR_CKE0_BIT      UINT32_C(0)

#define H8SCR_TIE           H8_BITNO_TO_BITPTN(H8SCR_TIE_BIT)
#define H8SCR_RIE           H8_BITNO_TO_BITPTN(H8SCR_RIE_BIT)
#define H8SCR_TE            H8_BITNO_TO_BITPTN(H8SCR_TE_BIT)
#define H8SCR_RE            H8_BITNO_TO_BITPTN(H8SCR_RE_BIT)
#define H8SCR_MPIE          H8_BITNO_TO_BITPTN(H8SCR_MPIE_BIT)
#define H8SCR_TEIE          H8_BITNO_TO_BITPTN(H8SCR_TEIE_BIT)
#define H8SCR_CKE1          H8_BITNO_TO_BITPTN(H8SCR_CKE1_BIT)
#define H8SCR_CKE0          H8_BITNO_TO_BITPTN(H8SCR_CKE0_BIT)
#define H8SCR_CKE_MASK      (H8SCR_CKE1 | H8SCR_CKE0)
#define H8SCR_IE            (H8SCR_TIE | H8SCR_RIE | H8SCR_MPIE | H8SCR_TEIE)

/* SCI Serial Status Register (SSR) */

#define H8SSR_TDRE_BIT      UINT32_C(7)
#define H8SSR_RDRF_BIT      UINT32_C(6)
#define H8SSR_ORER_BIT      UINT32_C(5)
#define H8SSR_FER_BIT       UINT32_C(4)
#define H8SSR_PER_BIT       UINT32_C(3)
#define H8SSR_TEND_BIT      UINT32_C(2)
#define H8SSR_MPB_BIT       UINT32_C(1)
#define H8SSR_MPBT_BIT      UINT32_C(0)

#define H8SSR_TDRE          H8_BITNO_TO_BITPTN(H8SSR_TDRE_BIT)
#define H8SSR_RDRF          H8_BITNO_TO_BITPTN(H8SSR_RDRF_BIT)
#define H8SSR_ORER          H8_BITNO_TO_BITPTN(H8SSR_ORER_BIT)
#define H8SSR_FER           H8_BITNO_TO_BITPTN(H8SSR_FER_BIT)
#define H8SSR_PER           H8_BITNO_TO_BITPTN(H8SSR_PER_BIT)
#define H8SSR_TEND          H8_BITNO_TO_BITPTN(H8SSR_TEND_BIT)
#define H8SSR_MPB           H8_BITNO_TO_BITPTN(H8SSR_MPB_BIT)
#define H8SSR_MPBT          H8_BITNO_TO_BITPTN(H8SSR_MPBT_BIT)

/* DRAM Control Registers */

#define H8DRCRA             UINT32_C(0xfee026)	/* Control Register A			*/
#define H8DRCRB             UINT32_C(0xfee027)	/* Control Register B			*/
#define H8RTMCSR            UINT32_C(0xfee028)	/* Timer Control / Status Register	*/
#define H8RTCNT             UINT32_C(0xfee029)	/* Reflesh Timer Counter		*/
#define H8RTCOR             UINT32_C(0xfee02a)	/* Reflesh Time Constant Register	*/

/* DRAM Control Register A */

#define H8DRCRA_DRAS2_BIT   UINT32_C(7)
#define H8DRCRA_DRAS1_BIT   UINT32_C(6)
#define H8DRCRA_DRAS0_BIT   UINT32_C(5)
#define H8DRCRA_BE_BIT      UINT32_C(3)
#define H8DRCRA_RDM_BIT     UINT32_C(2)
#define H8DRCRA_SRFMD_BIT   UINT32_C(1)
#define H8DRCRA_RFSHE_BIT   UINT32_C(0)

#define H8DRCRA_DRAS2       H8_BITNO_TO_BITPTN(H8DRCRA_DRAS2_BIT)
#define H8DRCRA_DRAS1       H8_BITNO_TO_BITPTN(H8DRCRA_DRAS1_BIT)
#define H8DRCRA_DRAS0       H8_BITNO_TO_BITPTN(H8DRCRA_DRAS0_BIT)
#define H8DRCRA_BE          H8_BITNO_TO_BITPTN(H8DRCRA_BE_BIT)
#define H8DRCRA_RDM         H8_BITNO_TO_BITPTN(H8DRCRA_RDM_BIT)
#define H8DRCRA_SRFMD       H8_BITNO_TO_BITPTN(H8DRCRA_SRFMD_BIT)
#define H8DRCRA_RFSHE       H8_BITNO_TO_BITPTN(H8DRCRA_RFSHE_BIT)

/* DRAM Control Register B */

#define H8DRCRB_MXC1_BIT    UINT32_C(7)
#define H8DRCRB_MXC0_BIT    UINT32_C(6)
#define H8DRCRB_CSEL_BIT    UINT32_C(5)
#define H8DRCRB_RCYCE_BIT   UINT32_C(4)
#define H8DRCRB_TPC_BIT     UINT32_C(2)
#define H8DRCRB_RCW_BIT     UINT32_C(1)
#define H8DRCRB_RLW_BIT     UINT32_C(0)

#define H8DRCRB_MXC1        H8_BITNO_TO_BITPTN(H8DRCRB_MXC1_BIT)
#define H8DRCRB_MXC0        H8_BITNO_TO_BITPTN(H8DRCRB_MXC0_BIT)
#define H8DRCRB_CSEL        H8_BITNO_TO_BITPTN(H8DRCRB_CSEL_BIT)
#define H8DRCRB_RCYCE       H8_BITNO_TO_BITPTN(H8DRCRB_RCYCE_BIT)
#define H8DRCRB_TPC         H8_BITNO_TO_BITPTN(H8DRCRB_TPC_BIT)
#define H8DRCRB_RCW         H8_BITNO_TO_BITPTN(H8DRCRB_RCW_BIT)
#define H8DRCRB_RLW         H8_BITNO_TO_BITPTN(H8DRCRB_RLW_BIT)

/* Reflesh Timer Control / Status Register */

#define H8RTMCSR_CMF_BIT    UINT32_C(7)
#define H8RTMCSR_CMIE_BIT   UINT32_C(6)
#define H8RTMCSR_CKS2_BIT   UINT32_C(5)
#define H8RTMCSR_CKS1_BIT   UINT32_C(4)
#define H8RTMCSR_CKS0_BIT   UINT32_C(3)

#define H8RTMCSR_CMF        H8_BITNO_TO_BITPTN(H8RTMCSR_CMF_BIT)
#define H8RTMCSR_CMIE       H8_BITNO_TO_BITPTN(H8RTMCSR_CMIE_BIT)
#define H8RTMCSR_CKS2       H8_BITNO_TO_BITPTN(H8RTMCSR_CKS2_BIT)
#define H8RTMCSR_CKS1       H8_BITNO_TO_BITPTN(H8RTMCSR_CKS1_BIT)
#define H8RTMCSR_CKS0       H8_BITNO_TO_BITPTN(H8RTMCSR_CKS0_BIT)

/*
 *  ¢
 */

#define H8IN_ROM_BASE       UINT32_C(0x000000)
#define H8IN_ROM_SIZE       UINT32_C(0x080000)
#define H8IN_RAM_BASE       UINT32_C(0xffbf10)
#define H8IN_RAM_SIZE       UINT32_C(0x004000)

#endif /* TOPPERS_H8_3069F_H_ */
